library jaguary_query.operators;

import 'package:jaguar_query/src/core/core.dart';

part 'int.dart';
part 'bool.dart';
part 'string.dart';
part 'column.dart';
part 'valuable.dart';

/// DSL to create 'is equal to' relational condition
Cond<ValType> eq<ValType>(String field, ValType rhs) => new Cond<ValType>(
    C<ValType>(field), ComparisonOperator.Eq, L.Make(rhs));

/// DSL to create 'is not equal to' relational condition
Cond<ValType> ne<ValType>(String field, ValType rhs) => new Cond<ValType>(
    C<ValType>(field), ComparisonOperator.Ne, L.Make(rhs));

/// DSL to create 'is greater than' relational condition
Cond<ValType> gt<ValType>(String field, ValType rhs) => new Cond<ValType>(
    C<ValType>(field), ComparisonOperator.Gt, L.Make(rhs));

/// DSL to create 'is greater than or equal to' relational condition
Cond<ValType> gtEq<ValType>(String field, ValType rhs) => new Cond<ValType>(
    C<ValType>(field), ComparisonOperator.GtEq, L.Make(rhs));

/// DSL to create 'is less than or equal to' relational condition
Cond<ValType> ltEq<ValType>(String field, ValType rhs) => new Cond<ValType>(
    C<ValType>(field), ComparisonOperator.LtEq, L.Make(rhs));

/// DSL to create 'is less than' relational condition
Cond<ValType> lt<ValType>(String field, ValType rhs) => new Cond<ValType>(
    C<ValType>(field), ComparisonOperator.Lt, L.Make(rhs));

/// DSL to create 'is like' relational condition
Cond<String> like(String field, String value) =>
    new Cond<String>(C<String>(field), ComparisonOperator.Like, L.Make(value));

/// DSL to create 'in-between' relational condition
InBetweenExpression<ValType> inBetween<ValType>(
        String field, ValType low, ValType high) =>
    new InBetweenExpression<ValType>(
        C<ValType>(field), L.Make(low), L.Make(high));
