part of jaguary_query.operators;

/// DSL to create 'is equal to' relational condition
Cond<String> eqStr(String field, String rhs) =>
    new Cond<String>(C<String>(field), ComparisonOperator.Eq, L.Str(rhs));

/// DSL to create 'is not equal to' relational condition
Cond<String> neStr(String field, String value) =>
    new Cond<String>(C<String>(field), ComparisonOperator.Ne, L.Str(value));

/// DSL to create 'is greater than' relational condition
Cond<String> gtStr(String field, String rhs) =>
    new Cond<String>(C<String>(field), ComparisonOperator.Gt, L.Str(rhs));

/// DSL to create 'is greater than or equal to' relational condition
Cond<String> gtEqStr(String field, String rhs) =>
    new Cond<String>(C<String>(field), ComparisonOperator.GtEq, L.Str(rhs));

/// DSL to create 'is less than or equal to' relational condition
Cond<String> ltEqStr(String field, String rhs) =>
    new Cond<String>(C<String>(field), ComparisonOperator.LtEq, L.Str(rhs));

/// DSL to create 'is less than' relational condition
Cond<String> ltStr(String field, String rhs) =>
    new Cond<String>(C<String>(field), ComparisonOperator.Lt, L.Str(rhs));

/// DSL to create 'in-between' relational condition
InBetweenExpression<String> inBetweenStr(
        String field, String low, String high) =>
    new InBetweenExpression<String>(C<String>(field), L.Str(low), L.Str(high));
