part of jaguary_query.operators;

/// DSL to create 'is equal to' relational condition
Cond<ValType> eqV<ValType>(String field, Valuable<ValType> rhs) =>
    new Cond<ValType>(C<ValType>(field), ComparisonOperator.Eq, rhs);

/// DSL to create 'is not equal to' relational condition
Cond<ValType> neV<ValType>(String field, Valuable<ValType> value) =>
    new Cond<ValType>(C<ValType>(field), ComparisonOperator.Ne, value);

/// DSL to create 'is greater than' relational condition
Cond<ValType> gtV<ValType>(String field, Valuable<ValType> value) =>
    new Cond<ValType>(C<ValType>(field), ComparisonOperator.Gt, value);

/// DSL to create 'is greater than or equal to' relational condition
Cond<ValType> gtEqV<ValType>(String field, Valuable<ValType> value) =>
    new Cond<ValType>(C<ValType>(field), ComparisonOperator.GtEq, value);

/// DSL to create 'is less than or equal to' relational condition
Cond<ValType> ltEqV<ValType>(String field, Valuable<ValType> value) =>
    new Cond<ValType>(C<ValType>(field), ComparisonOperator.LtEq, value);

/// DSL to create 'is less than' relational condition
Cond<ValType> ltV<ValType>(String field, Valuable<ValType> value) =>
    new Cond<ValType>(C<ValType>(field), ComparisonOperator.Lt, value);

/// DSL to create 'is like' relational condition
Cond<String> likeV(String field, Valuable<String> value) =>
    new Cond<String>(C<String>(field), ComparisonOperator.Like, value);

/// DSL to create 'in-between' relational condition
InBetweenExpression<ValType> inBetweenV<ValType>(
        String field, Valuable<ValType> low, Valuable<ValType> high) =>
    new InBetweenExpression<ValType>(C<ValType>(field), low, high);
